GETTIMEOFDAY(2)

NAME
gettimeofday, settimeofday - get/set date and time

SYNOPSIS
#include <sys/time.h>
int
gettimeofday(struct timeval *tp, struct timezone *tzp);
int
settimeofday(const struct timeval *tp, const struct timezone *tzp);

DESCRIPTION
Note: time zone information is no longer provided by this interface. See localtime(3) for information on how to retrieve it.

The system's notion of the current UTC time is obtained with the gettimeofday() call, and set with the settimeofday() call. The time is expressed in seconds and microseconds since midnight (0 hour), January 1, 1970. The resolution of the system clock is hardware dependent, and the time may be updated continuously or in ``ticks.'' If tp is NULL, the time will not be returned or set.

The structures pointed to by tp and tzp are defined in <sys/time.h> as:

    struct timeval {
    	long	tv_sec;		/* seconds since Jan. 1, 1970 */
    	long	tv_usec;	/* and microseconds */
    };
    struct timezone {
    	int	tz_minuteswest; /* of Greenwich */
    	int	tz_dsttime;	/* type of dst correction to apply */
    };

The timezone structure is provided only for source compatibility. It is ignored by settimeofday(), and gettimeofday() will always return zeroes.

Only the super-user may set the time of day.

RETURN
A 0 return value indicates that the call succeeded. A -1 return value indicates an error occurred, and in this case an error code is stored into the global variable errno.

ERRORS
The following error codes may be set in errno:

[EFAULT]
    An argument address referenced invalid memory.

[EPERM]
    A user other than the super-user attempted to set the time, or the specified time was less than the current time, which was not permitted at the current security level.

SEE ALSO
date(1), adjtime(2), ctime(3), localtime(3), timed(8)

HISTORY
The gettimeofday() function call appeared in 4.2BSD. The tzp argument was deprecated in 4.4BSD (and many other systems).